      SUBROUTINE FREDA(IMIN,IMAX)
C****
C**** Free-format reading routine.
C**** Returns kn numbers in fn, kl literals in fl
C****
      CHARACTER FL,COL,ICH,INUM
C****
      COMMON /FRC   / COL(80),FL(6,40)
      COMMON /FRN   / FN(40),NCHAR,KN,KL
      COMMON /IO    / IN
C****
      DIMENSION INUM(10)
C****
      DATA INUM/'1','2','3','4','5','6','7','8','9','0'/
C****
      KN=0
      KL=0
      I=IMIN-1
C****
C**** Start of a new field
C**** Look for a non-blank column
C****
    1 A=0.0
      IP=0
      P=1.
      L=0
      S=1.0
    2 I=I+1
      IF(I.GT.IMAX)GO TO 8
      ICH=COL(I)
      IF(L.EQ.0.AND.ICH.EQ.' ')GO TO 2
C****
C**** Start of a field
C****
      L=L+1
      DO 3 J=1,10
         IF(ICH.EQ.INUM(J))GO TO 4
    3 CONTINUE
      IF(ICH.EQ.'.')GO TO 5
      IF(ICH.EQ.'+')GO TO 6
      IF(ICH.EQ.'-')GO TO 7
      IF(ICH.EQ.'=')GO TO 16
      IF(L.GT.1)GO TO 9
      GO TO 10
C****
C**** Numeric field found
C****
    4 IF(J.EQ.10)J=0
      IF(IP.EQ.1)P=P*0.1
      A=10.0*A+FLOAT(J)
      GO TO 2
C****
    5 IP=1
      GO TO 2
C****
    6 IF(L.GT.1)GO TO 9
      S=1.0
      GO TO 2
C****
    7 IF(L.GT.1)GO TO 9
      S=-1.0
      GO TO 2
C****
    8 IF(L.GT.0)GO TO 9
      RETURN
C****
C**** End of numeric field
C****
    9 A=S*A*P
      IF(KN.GE.40)GO TO 20
      KN=KN+1
      FN(KN)=A
      IF(ICH.EQ.'+'.OR.ICH.EQ.'-'.OR.ICH.EQ.'=')I=I-1
      GO TO 1
C****
C**** Literal field
C****
   10 IF(KL.GE.40)GO TO 22
      KL=KL+1
   11 FL(L,KL)=ICH
      L=L+1
      IF(L.GT.NCHAR)GO TO 13
      I=I+1
      IF(I.GT.IMAX)GO TO 14
      ICH=COL(I)
      IF(ICH.EQ.' ')GO TO 14
      GO TO 11
C****
   13 I=I+1
      IF(I.GT.IMAX)RETURN
      IF(COL(I).EQ.' ')GO TO 1
      GO TO 13
C****
C**** End of literal field defined by blank
C****
   14 DO 15 J=L,NCHAR
         FL(J,KL)=' '
   15 CONTINUE
      GO TO 1
C****
C**** Continuation card
C****
   16 IF(L.GT.1)GO TO 9
      READ(IN,17)COL
      WRITE(6,18)COL
      I=1
      IMAX=80
      GO TO 1
C****
C**** Errors
C****
   20 WRITE(6,21)
      RETURN
C****
   22 WRITE(6,23)
      RETURN
C****
   17 FORMAT(80A1)
   18 FORMAT(' ===',80A1)
   21 FORMAT('0*** Too many numbers given: only first 40 accepted',//)
   23 FORMAT('0*** Too many literals given: only first 40 accepted',//)
C****
      END

